Global("WW", userMods.GetGlobalConfigSection("WW"))

Global("MainPanel", mainForm:GetChildChecked("MainPanel", false))
Global("WhisperBtn", mainForm:GetChildChecked("WhisperBtn", false))
Global("Container", MainPanel:GetChildChecked("Container", false))
Global("DPanel", mainForm:GetChildChecked("DPanel", false))
Global("TextContainer", {} )
Global("TypeBtn", {})
Global("X", 0 )
Global("MPInit", nil )

Global("L", {})
Global("Texts", {
	[ "eng" ]  = {
		[ "Whisper" ] = "Whisper",
		[ "Zone" ] = "Zone",
		[ "Group" ] = "Group",
		[ "Say" ] = "Say",
		[ "Guild" ] = "Guild",
		[ "Omni" ] = "All",
		[ "None" ] = " no one",
		[ "Self" ] = " self",
		[ "To" ] = " to",
		[ "From" ] = " from",
		[ "Raid" ] = "Raid",
		[ "Emote" ] = "Emote",
		[ "World" ] = "World",
		[ "Shout" ] = "Shout",
		[ "Officer" ] = "Officer",
		[ "System" ] = "System",
		[ "Telepathy" ] = "Telepathy",
		[ "Online" ] = "is online.",
		[ "Offline" ] = "is offline.",
		[ "BG" ] = "Background",
	},
	
	[ "rus" ]  = {
		[ "Whisper" ] = "",
		[ "Zone" ] = "",
		[ "Group" ] = "",
		[ "Guild" ] = "",
		[ "Say" ] = "",
		[ "Omni" ] = "",
		[ "None" ] = " ",
		[ "Self" ] = " ",
		[ "To" ] = "",
		[ "From" ] = "  ",
		[ "Raid" ]   = "",
		[ "Emote" ]   = "",
		[ "World" ]   = "",
		[ "Shout" ]   = "",
		[ "Officer" ]   = "",
		[ "System" ]   = "",
		[ "Telepathy" ]   = "",
		[ "Online" ]   = "  .",
		[ "Offline" ]   = "  .",
		[ "BG" ] = "",
	},

	[ "fra" ] = {
		[ "Whisper" ] = "Murmure",
		[ "Zone" ] = "Zone",
		[ "Group" ] = "Groupe",
		[ "Guild" ] = "Guild",
		[ "Say" ] = "Say",
		[ "Omni" ] = "Tous",
		[ "None" ] = " personne",
		[ "Self" ] = "  moi-mme",
		[ "To" ] = " ",
		[ "From" ] = " de",
		[ "Raid" ] = "Raid",
		[ "Emote" ] = "Emote",
		[ "World" ] = "Monde",
		[ "Shout" ] = "Shout",
		[ "Officer" ] = "Officier",
		[ "System" ] = "Systme",
		[ "Telepathy" ] = "Tlpathie",
		[ "Online" ] = "est en ligne.",
		[ "Offline" ] = "est dconnect.",
		[ "BG" ] = "de Fond",
	},
	
	[ "ger" ] = {
		[ "Whisper" ] = "Flstern",
		[ "Zone" ] = "Zone",
		[ "Group" ] = "Gruppe",
		[ "Guild" ] = "Gilde",
		[ "Say" ] = "Sagen",
		[ "Omni" ] = "Alle",
		[ "None" ] = " niemand",
		[ "Self" ] = " selbst",
		[ "To" ] = " zu",
		[ "From" ] = " von",
		[ "Raid" ] = "berfall",
		[ "Emote" ] = "Emote",
		[ "World" ] = "Welt",
		[ "Shout" ] = "Schreien",
		[ "Officer" ] = "Offizier",
		[ "System" ] = "System",
		[ "Telepathy" ] = "Telepathie",
		[ "Online" ] = "ist online.",
		[ "Offline" ] = "ist offline.",
		[ "BG" ] = "Hintergrund",
	},
	
	[ "jp" ] = {
		[ "Whisper" ] = "\179\168\189\202\223\176",
		[ "Zone" ] = "\191\222\176\191",
		[ "Group" ] = "\184\222\217\176\204\223",
		[ "Guild" ] = "\183\222\217\196\222",
		[ "Say" ] = "\190\168",
		[ "Omni" ] = "All",
		[ "None" ] = " no one",
		[ "Self" ] = " self",
		[ "To" ] = " to",
		[ "Raid" ] = "Raid",
		[ "Emote" ] = "Emote",
		[ "World" ] = "\220\176\217\196\222",
		[ "Shout" ] = "Shout",
		[ "Officer" ] = "Officer",
		[ "System" ] = "System",
		[ "Telepathy" ] = "Telepathy",
		[ "Online" ] = "is online.",
		[ "Offline" ] = "is offline.",
		[ "BG" ] = "Background",
	},
})

Global("IQColor",  {
	[ ITEM_QUALITY_JUNK ]  = "Junk",
	[ ITEM_QUALITY_GOODS ]  = "Goods",
	[ ITEM_QUALITY_COMMON ]  = "Common",
	[ ITEM_QUALITY_UNCOMMON ]  = "Uncommon",
	[ ITEM_QUALITY_RARE ]  = "Rare",
	[ ITEM_QUALITY_EPIC ]  = "Epic",
})

Global("hour", 0 )
Global("minute", 0 )
Global("second", 0 )
Global("FORMAT", nil)
Global("Name", nil)
Global("MessageText", nil)

Global("TextColor", {
	["Gold"] = "LogColorGold",
	["Blue"] = "LogColorBlue",
	["White"] = "LogColorWhite",
	["Grey"] = "LogColorBlack",
	["Yellow"] = "LogColorYellow",
	["Cian"] = "LogColorCian",
	["Red"] = "LogColorRed",
	["Magenta"] = "LogColorMagenta",
	["Violet"] = "LogColorViolet",
	["Green"] = "LogColorGreen",
	["LightGreen"] = "LogColorLightGreen",
	["Brown"] = "LogColorBrown",
	["Orange"] = "LogColorOrange",
	["LightRed"] = "LogColorLightRed",
})

Global("BackgroundColor", {
	["Gold"] = {r = .5; g = .5; b = 0; a = .7},
	["Blue"] = {r = 0; g = 0; b = 1; a = .7},
	["White"] = {r = 1; g = 1; b = 1; a = .7},
	["Grey"] = {r = .5; g = .5; b = .5; a = .7},
	["Black"] = {r = 0; g = 0; b = 0; a = .7},
	["Yellow"] = {r = 1; g = 1; b = 0; a = .7},
	["Cian"] = {r = 0; g = 1; b = 1; a = .7},
	["Red"] = {r = 1; g = 0; b = 0; a = .7},
	["Magenta"] = {r = 1; g = 0; b = 1; a = .7},
	["Violet"] = {r = .5; g = 0; b = 1; a = .7},
	["Green"] = {r = 0; g = .5; b = 0; a = .7},
	["LightGreen"] = {r = 0; g = 1; b = 0; a = .7},
	["Brown"] = {r = .5; g = .25; b = 0; a = .7},
	["Orange"] = {r = 1; g = .5; b = 0; a = .7},
	["LightRed"] = {r = 1; g = .5; b = .5; a = .7},
})

Global("Popup", mainForm:GetChildChecked("Popup", false))
Global("ColorOptions", nil)
Global("PopupText", {})
Global("PopupBtn", {})
Global("ColorBtn", {})
Global("ColorBtnDesc", nil)

Global("Sender", nil)

Global("WWBtn", mainForm:GetChildChecked("WWBtn", false))

-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
function WritePopup()
	PopupText[0]:SetVal("name", userMods.ToWString("WhisperWindow") )
	PopupText[1]:SetVal("name", userMods.ToWString("Size: "..WW["Size"]) )
	PopupText[2]:SetVal("name", userMods.ToWString("Font: "..WW["Font"]) )
	PopupText[3]:SetVal("name", userMods.ToWString("Time: "..tostring(WW["Time"])) )
	PopupText[4]:SetVal("name", userMods.ToWString("Transparency: "..WW["Trans"]))
	PopupBtn[0]:SetVal("name", L["Whisper"])
	PopupBtn[0]:SetBackgroundColor( BackgroundColor[WW["Whisper"]] )
	PopupBtn[1]:SetVal("name", L["Zone"])
	PopupBtn[1]:SetBackgroundColor( BackgroundColor[WW["Zone"]] )
	PopupBtn[2]:SetVal("name", L["Group"])
	PopupBtn[2]:SetBackgroundColor( BackgroundColor[WW["Group"]] )
	PopupBtn[3]:SetVal("name", L["Say"])
	PopupBtn[3]:SetBackgroundColor( BackgroundColor[WW["Say"]] )
	PopupBtn[4]:SetVal("name", L["Guild"])
	PopupBtn[4]:SetBackgroundColor( BackgroundColor[WW["Guild"]] )
	PopupBtn[5]:SetVal("name", L["Officer"])
	PopupBtn[5]:SetBackgroundColor( BackgroundColor[WW["Officer"]] )
	PopupBtn[6]:SetVal("name", L["Raid"])
	PopupBtn[6]:SetBackgroundColor( BackgroundColor[WW["Raid"]] )
	PopupBtn[7]:SetVal("name", L["Shout"])
	PopupBtn[7]:SetBackgroundColor( BackgroundColor[WW["Shout"]] )
	PopupBtn[8]:SetVal("name", L["World"])
	PopupBtn[8]:SetBackgroundColor( BackgroundColor[WW["World"]] )
	PopupBtn[9]:SetVal("name", L["Emote"])
	PopupBtn[9]:SetBackgroundColor( BackgroundColor[WW["Emote"]] )
	PopupBtn[10]:SetVal("name", L["Telepathy"])
	PopupBtn[10]:SetBackgroundColor( BackgroundColor[WW["Telepathy"]] )
	PopupBtn[11]:SetVal("name", L["System"])
	PopupBtn[11]:SetBackgroundColor( BackgroundColor[WW["System"]] )
	PopupBtn[12]:SetVal("name", L["BG"])
	PopupBtn[12]:SetBackgroundColor( BackgroundColor[WW["BG"]] )
	PopupBtn[13]:SetVal("name", userMods.ToWString("Type: "..tostring(WW["Type"])))
	PopupBtn[13]:SetBackgroundColor( BackgroundColor.Black )
end

function OnEventChat( params )
	
	if params.messages then --CODE BY DUVODAS, MODIFIED
		local simpleMessage = userMods.ToWString( "<html><r name='text'/></html>" )
		local messageWithObject = userMods.ToWString( "<html><r name='text'/><rs class='quality'>[<r name='item'/>]</rs></html>" )		
		local fragments = {}
		local format = { "<html>" }
		for i = 0, table.getn( params.messages ) + 1 do
			local v = params.messages[ i ]
			if v then
				table.insert( fragments, common.CreateValuedText() )
				fragments[ i + 1 ]:SetFormat( v.item and messageWithObject or simpleMessage )
				fragments[ i + 1 ]:SetVal( "text", v.text or common.GetEmptyWString() )
				if v.item then
					if v.item:GetType() == VAL_OBJ_TYPE_ITEM then
						local info = avatar.GetItemInfo( v.item:GetId() )
						fragments [ i + 1 ] :SetClassVal( "quality", IQColor [info.quality]  .. ( info.isCursed and "Cursed" or "" ) )
					end
					fragments[ i + 1 ]:SetVal( "item", v.item )					
				end
				table.insert( format, "<r name = 'value"..( i + 1 ).."'/> " )				
			end
		end		
		table.insert( format, "</html>" )
		format = table.concat( format )
		local msg = common.CreateValuedText()
		msg:SetFormat( userMods.ToWString( format ) )
		for i, v in ipairs( fragments ) do
			msg:SetVal( "value"..i, v )
		end
		MessageText = msg
	else
		MessageText = params.msg
	end
	
	Name = params.sender
	
	if params.chatType == CHAT_TYPE_WHISPER then --WHISPER, WHISPER
		local ToF
		
		if not params.recipient and avatar.GetId() == params.senderId then
			Name = params.sender
			ToF = L["Self"]
		elseif avatar.GetId() == params.senderId then
			Name = params.recipient
			ToF = L["To"]
		else
			Name = params.sender
			ToF = L["From"]
		end
		
		
		Message( nil, WW["Whisper"], 5, ToF )
		Message( nil, WW["Whisper"], 0, ToF )
	end
	
	if params.chatType == CHAT_TYPE_ZONE then --ZONE, ZONE
		Message( L["Zone"], WW["Zone"], 1 )
		Message( L["Zone"], WW["Zone"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_WORLD then --WORLD, ZONE
		Message( L["World"], WW["World"], 1 )
		Message( L["World"], WW["World"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_YELL_ZONE then --SHOUT, ZONE
		Message( L["Shout"], WW["Shout"], 1 )
		Message( L["Shout"], WW["Shout"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_NOTICE then --NOTICE, ZONE
		Message( L["System"], WW["System"], 1 )
		Message( L["System"], WW["System"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_PARTY then --GROUP, GROUP
		Message( L["Group"], WW["Group"], 2 )
		Message( L["Group"], WW["Group"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_RAID then --RAID, GROUP
		Message( L["Raid"], WW["Raid"], 2 )
		Message( L["Raid"], WW["Raid"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_SAY then --SAY, SAY
		Message( L["Say"], WW["Say"], 3 )
		Message( L["Say"], WW["Say"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_PSIONIC then --TELEPATHY, SAY
		Message( L["Telepathy"], WW["Telepathy"], 3 )
		Message( L["Telepathy"], WW["Telepathy"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_GUILD then --GUILD, GUILD
		Message( L["Guild"], WW["Guild"], 4 )
		Message( L["Guild"], WW["Guild"], 0 )
	end
	
	if params.chatType == CHAT_TYPE_GUILD_OFFICER then --OFFICER, GUILD
		Message( L["Officer"], WW["Officer"], 4 )
		Message( L["Officer"], WW["Officer"], 0 )
	end
end

function EmoteChat( params )
	Name = object.GetName(params.id)
	MessageText = userMods.ToWString(userMods.FromWString(params.text)..".")
	Message( L["Emote"], WW["Emote"], 3 )
	Message( L["Emote"], WW["Emote"], 0 )
end

function Message( variety, color, number, tof )
	local valuedText = common.CreateValuedText()
		
	valuedText:SetFormat( FORMAT )
	valuedText:ClearValues()
	valuedText:SetClassVal( "class", TextColor[color] )
	if WW["Time"] then
		local function Zorro( num ) return num < 10 and "0"..num or num end -- Z ^_^ --FUNCTION BY DUVODAS
		local ptime = mission.GetWorldTimeHMS()
		hour = Zorro(ptime.h)
		minute = Zorro(ptime.m)
		second = Zorro(ptime.s)
		valuedText:SetVal("time", userMods.ToWString( "("..hour..":"..minute..":"..second..") " ))
	end
	if WW["Type"] and variety then
		valuedText:SetVal( "type", userMods.ToWString("["..userMods.FromWString(variety).."]") )
	end
	valuedText:SetVal( "name", unit.GetPlayerValuedObject(Name) )
	if tof then
		valuedText:SetVal( "tof", tof )
	end
	valuedText:SetVal( "text", MessageText )
	TextContainer[number]:PushFrontValuedText( valuedText )
end

function OnReactionWhisperBtn( reaction ) --LEFT CLICK
	for i = 0, 5 do
		TextContainer[i]:Show(false)
	end
	if reaction.sender == "WhisperBtn" then
		TextContainer[5]:Show(true)
		WW["Current"] = 5
	elseif reaction.sender == "ZoneBtn" then
		TextContainer[1]:Show(true)
		WW["Current"] = 1
	elseif reaction.sender == "GroupBtn" then
		TextContainer[2]:Show(true)
		WW["Current"] = 2
	elseif reaction.sender == "SayBtn" then
		TextContainer[3]:Show(true)
		WW["Current"] = 3
	elseif reaction.sender == "GuildBtn" then
		TextContainer[4]:Show(true)
		WW["Current"] = 4
	elseif reaction.sender == "OmniBtn" then
		TextContainer[0]:Show(true)
		WW["Current"] = 0
	end
	userMods.SetGlobalConfigSection("WW", WW )
end

function OnReactionClearBtn( reaction ) --RIGHT CLICK
	OnReactionWhisperBtn( reaction )
end

function WWConfigBtn()
	WritePopup()
	Popup:Show(not Popup:IsVisible())
	ColorOptions:Show(false)
end

function Open( params )
	if userMods.FromWString( params.text ) == "/ww" then --OPEN
		MainPanel:Show( not MainPanel:IsVisible() )
		for i = 0, 5 do
			TypeBtn[i]:Show(not TypeBtn[i]:IsVisible())
		end
		DPanel:Show(not DPanel:IsVisible())
	elseif userMods.FromWString( params.text ) == "/wwreset" then --RESET DND
		userMods.SetGlobalConfigSection("WhisperWindow", {})
		common.StateUnloadManagedAddon( "UserAddon/"..common.GetAddonName() )
		common.StateLoadManagedAddon( "UserAddon/"..common.GetAddonName() )
	elseif userMods.FromWString( params.text ) == "/wwtime" then --TIMESTAMP
		WW["Time"] = not WW["Time"]
		userMods.SetGlobalConfigSection("WW", WW )
	elseif userMods.FromWString( params.text ) == "/wwclear" then --CLEAR
		for i = 0, 5 do
			if TextContainer[i]:IsVisible() then
				TextContainer[i]:RemoveItems()
			end
		end
	elseif userMods.FromWString( params.text ) == "/wwconfig" then
		WritePopup()
		Popup:Show(not Popup:IsVisible())
		ColorOptions:Show(false)
	elseif common.IsSubstring(params.text, userMods.ToWString("/wwtrans")) then
		local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 9)))
		if number and number <= 10 and number >= 0 then
			WW["Trans"] =  number / 10
		end
		local color = MainPanel:GetBackgroundColor()
		color.a = WW["Trans"]
		MainPanel:SetBackgroundColor(color)
		userMods.SetGlobalConfigSection("WW", WW )
	else
		if common.IsSubstring(params.text, userMods.ToWString("/wwsize")) then
			local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 9)))
			if number then
				WW["Size"] =  number
			end
			userMods.SetGlobalConfigSection("WW", WW )
		end
		if userMods.FromWString( params.text ) == "/wwsys" then --FONT CHANGE
			WW["Font"] = "AllodsSystem"
			userMods.SetGlobalConfigSection("WW", WW)
		end
		if userMods.FromWString( params.text ) == "/wwfan" then --FONT CHANGE
			WW["Font"] = "AllodsWest"
			userMods.SetGlobalConfigSection("WW", WW)
		end
		FORMAT = userMods.ToWString("<header alignx=\"left\" fontsize=\""..WW["Size"].."\" fontname = \""..WW["Font"].."\"><rs class=\"class\"><r name=\"time\"/><r name=\"type\"/>[<r name=\"name\"/>]<r name=\"tof\"/>: <r name=\"text\"/></rs></header>")
	end
	WritePopup()
end

function PopupCP(Type)
	local num = 0
	for i, v in Type or TextColor do
		if not ColorBtn[i] then
			ColorBtn[i] = mainForm:CreateWidgetByDesc(ColorBtnDesc)
			ColorOptions:AddChild(ColorBtn[i])
		end
		local P = ColorBtn[i]:GetPlacementPlain()
		P.alignX = WIDGET_ALIGN_LOW
		P.posX = 20 * num
		P.sizeX = 20
		P.sizeY = 20
		ColorBtn[i]:SetPlacementPlain(P)
		num = num + 1
		ColorBtn[i]:SetBackgroundColor(BackgroundColor[i])
		ColorBtn[i]:SetName("ColorBtn"..i)
		ColorBtn[i]:Show(true)
	end
	local P = ColorOptions:GetPlacementPlain()
	P.sizeX = num * 20
	P.sizeY = 20
	ColorOptions:SetPlacementPlain(P)
end

function PopupBtns( reaction )
	local owner = reaction.sender
	if owner == "Whisper" then
		PopupCP()
		Sender = "Whisper"
		ColorOptions:Show(true)
	elseif owner == "Zone" then
		PopupCP()
		Sender = "Zone"
		ColorOptions:Show(true)
	elseif owner == "Group" then
		PopupCP()
		Sender = "Group"
		ColorOptions:Show(true)
	elseif owner == "Say" then
		PopupCP()
		Sender = "Say"
		ColorOptions:Show(true)
	elseif owner == "Guild" then
		PopupCP()
		Sender = "Guild"
		ColorOptions:Show(true)
	elseif owner == "Officer" then
		PopupCP()
		Sender = "Officer"
		ColorOptions:Show(true)
	elseif owner == "Telepathy" then
		PopupCP()
		Sender = "Telepathy"
		ColorOptions:Show(true)
	elseif owner == "World" then
		PopupCP()
		Sender = "World"
		ColorOptions:Show(true)
	elseif owner == "Emote" then
		PopupCP()
		Sender = "Emote"
		ColorOptions:Show(true)
	elseif owner == "Raid" then
		PopupCP()
		Sender = "Raid"
		ColorOptions:Show(true)
	elseif owner == "Shout" then
		PopupCP()
		Sender = "Shout"
		ColorOptions:Show(true)
	elseif owner == "System" then
		PopupCP()
		Sender = "System"
		ColorOptions:Show(true)
	elseif owner == "BG" then
		PopupCP(BackgroundColor)
		Sender = "BG"
		ColorOptions:Show(true)
	elseif owner == "ChatType" then
		WW["Type"] = not WW["Type"]
		userMods.SetGlobalConfigSection("WW", WW)
		WritePopup()
	elseif common.IsSubstring(userMods.ToWString(owner), userMods.ToWString("ColorBtn")) then
		local color = string.sub(owner, 9)
		WW[Sender] = color
		userMods.SetGlobalConfigSection("WW", WW)
		ColorOptions:Show(false)
		WritePopup()
		MainPanel:SetBackgroundColor( BackgroundColor[WW["BG"]] )
		local color = MainPanel:GetBackgroundColor()
		color.a = WW["Trans"]
		MainPanel:SetBackgroundColor(color)
	end
end

function FriendOnline( params )
	if params then
		Name = params.name
		if params.isOnline then
			MessageText = L["Online"]
		else
			MessageText = L["Offline"]
		end
		Message( nil, WW["System"], 0 )
	end
end

function GuildOnline( params )
	if params then
		Name = params.name
		if "EVENT_GUILD_MEMBER_ONLINE" then
			MessageText = L["Online"]
		elseif "EVENT_GUILD_MEMBER_OFFLINE" then
			MessageText = L["Offline"]
		end
		Message( nil, WW["Guild"], 0 )
		Message( nil, WW["Guild"], 4 )
	end
end

function RWWBtn( reaction )
	MainPanel:Show( not MainPanel:IsVisible() )
	for i = 0, 5 do
		TypeBtn[i]:Show(not TypeBtn[i]:IsVisible())
	end
	DPanel:Show(not DPanel:IsVisible())
end

-- AO game Localization detection by SLA. Version 2011-01-29.
function GetGameLocalization()
	local B = cartographer.GetMapBlocks()
	local T = { rus = "\209\226\255\242\224\255 \199\229\236\235\255",
	eng = "Holy Land", ger = "Heiliges Land", fra = "Terre Sacr\233e", 
	jp = "JjA"}
	for b in B do for l,t in T do
		if userMods.FromWString( cartographer.GetMapBlockInfo(B [b] ).name ) == t then return l end
	end end; return "eng"
end

--ADDON MANAGER COOPERATION
function OnEventAMMemUsageRequest() --MEMORY
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function OnScriptToggleUI( params ) --UI TOGGLE
	mainForm:Show( params.visible )
end

function OnEventAMToggleDnD( params ) --DND TOGGLE
	if params.target == common.GetAddonName() then
		DnD:Enable( MainPanel, params.state )
		DnD:Enable( DPanel, params.state )
		for i = 0, 5 do
			DnD:Enable( TypeBtn[i], params.state )
		end
	end
end

--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
--LOCALIZATION
	L = Texts[ GetGameLocalization() ]
	for i, v in L do
		L[i] = userMods.ToWString( L[i] )
	end
	
	if not WW or WW["Trans"] == nil then
		if not WW or WW["Type"] == nil then
			WW = {}
			WW["Size"] = 16
			WW["Font"] = "AllodsSystem"
			WW["Time"] = false
			WW["Type"] = true
			WW["Whisper"] = "Magenta"
			WW["Zone"] = "Brown"
			WW["Group"] = "Blue"
			WW["Say"] = "White"
			WW["Raid"] = "Red"
			WW["Guild"] = "LightGreen"
			WW["Officer"] = "Green"
			WW["Telepathy"] = "Yellow"
			WW["World"] = "Gold"
			WW["Emote"] = "Orange"
			WW["Shout"] = "Cian"
			WW["System"] = "Yellow"
			WW["Current"] = 0
		end
		WW["BG"] = "Black"
		WW["Trans"] = .5
		userMods.SetGlobalConfigSection("WW", WW)
	end
	
	FORMAT = userMods.ToWString("<header alignx=\"left\" fontsize=\""..WW["Size"].."\" fontname = \""..WW["Font"].."\"><rs class=\"class\"><r name=\"time\"/><r name=\"type\"/>[<r name=\"name\"/>]<r name=\"tof\"/>: <r name=\"text\"/></rs></header>")

	common.RegisterReactionHandler( OnReactionWhisperBtn, "WhisperBtn" )
	common.RegisterReactionHandler( OnReactionClearBtn, "ClearBtn" )
	if GetGameLocalization() == "rus" then
		common.RegisterEventHandler( OnEventChat, "EVENT_CHAT_MESSAGE_WITH_OBJECTS")
	else
		common.RegisterEventHandler( OnEventChat, "EVENT_CHAT_MESSAGE" )
	end
	
	if GetGameLocalization() == "rus" then
		IQColor[ ITEM_QUALITY_LEGENDARY ]  = "Legendary"
		IQColor[ ITEM_QUALITY_RELIC ]  = "Relic"
	end
	common.RegisterEventHandler( Open, "EVENT_UNKNOWN_SLASH_COMMAND" )
	
	common.RegisterEventHandler( FriendOnline, "EVENT_AVATAR_FRIEND_ONLINE_CHANGED" )
	
	common.RegisterEventHandler( GuildOnline, "EVENT_GUILD_MEMBER_ONLINE" )
	common.RegisterEventHandler( GuildOnline, "EVENT_GUILD_MEMBER_OFFLINE" )
	
	common.RegisterEventHandler( EmoteChat, "EVENT_EMOTE_TEXT" )
	
	common.RegisterReactionHandler( PopupBtns, "PopupBtn" )
	common.RegisterReactionHandler( RWWBtn, "WWBtn" )
	common.RegisterReactionHandler( WWConfigBtn, "WWConfig" )
		
-- ADDON MANAGER EVENTS (MEMORY, DND TOGGLE, UI TOGGLE)
	common.RegisterEventHandler( OnEventAMMemUsageRequest, "U_EVENT_ADDON_MEM_USAGE_REQUEST" )
	common.RegisterEventHandler( OnEventAMToggleDnD, "U_EVENT_TOGGLE_DND" )
	common.RegisterEventHandler( OnScriptToggleUI, "SCRIPT_TOGGLE_UI" )
	
	MainPanel:SetBackgroundColor( BackgroundColor[WW["BG"]] )
	local color = MainPanel:GetBackgroundColor()
	color.a = WW["Trans"]
	MainPanel:SetBackgroundColor( color )
	MainPanel:Show(true)
	DPanel:SetBackgroundColor( {r = 1; g = 1; b = 1; a = .65} )
	DPanel:Show(true)
	for i = 0, 5 do
		TextContainer[i] = mainForm:CreateWidgetByDesc( Container:GetWidgetDesc() )
		MainPanel:AddChild( TextContainer[i] )
		TextContainer[i]:Show(false)
		TypeBtn[i] = mainForm:CreateWidgetByDesc( WhisperBtn:GetWidgetDesc() )
		mainForm:AddChild( TypeBtn[i] )
		TypeBtn[i]:Show(true)
	end
	Container:DestroyWidget()
	WhisperBtn:DestroyWidget()
	TextContainer[WW["Current"]]:Show(true)
	
	TypeBtn[0]:SetVal("name", L["Omni"])
	TypeBtn[0]:SetName( "OmniBtn" )
	TypeBtn[1]:SetVal("name", L["Zone"])
	TypeBtn[1]:SetName( "ZoneBtn" )
	TypeBtn[2]:SetVal("name", L["Group"])
	TypeBtn[2]:SetName( "GroupBtn" )
	TypeBtn[3]:SetVal("name", L["Say"])
	TypeBtn[3]:SetName( "SayBtn" )
	TypeBtn[4]:SetVal("name", L["Guild"])
	TypeBtn[4]:SetName( "GuildBtn" )
	TypeBtn[5]:SetVal("name", L["Whisper"])
	TypeBtn[5]:SetName( "WhisperBtn" )
	
	DnD:Init( 678, MainPanel, MainPanel, true )
	
	local MP = MainPanel:GetPlacementPlain()
	local DragP = DPanel:GetPlacementPlain()
	DragP.posX = MP.sizeX - 16 + MP.posX
	DragP.posY = MP.sizeY - 16 + MP.posY
	DPanel:SetPlacementPlain(DragP)
	
	DnD:Init( 685, DPanel, DPanel, true )
	
	local MP = MainPanel:GetPlacementPlain()
	local DragP = DPanel:GetPlacementPlain()
	local TC = TextContainer[0]:GetPlacementPlain()
	MP.sizeX = DragP.posX - MP.posX + 16
	TC.sizeX = MP.sizeX
	MP.sizeY = DragP.posY - MP.posY + 16
	TC.sizeY = MP.sizeY
	MainPanel:SetPlacementPlain(MP)
	for i = 0, 5 do
		TextContainer[i]:SetPlacementPlain(TC)
	end
	
	for i = 0, 5 do
		local P = TypeBtn[i]:GetPlacementPlain()
		P.posX = MP.posX + (i * 70) + 40
		P.posY = MP.posY + MP.sizeY - 20
		TypeBtn[i]:SetPlacementPlain(P)
	end
	
	local P = WWBtn:GetPlacementPlain()
	P.posX = MP.posX
	P.posY = MP.posY + MP.sizeY - 20
	WWBtn:SetPlacementPlain(P)
	
	Popup:SetBackgroundColor( BackgroundColor.Black )
	local PopupDesc = Popup:GetWidgetDesc()
	ColorOptions = mainForm:CreateWidgetByDesc( PopupDesc )
	ColorOptions:SetBackgroundColor( BackgroundColor.Black )
	
	local P = Popup:GetPlacementPlain()
	P.posX = P.posX + P.sizeX
	ColorOptions:SetPlacementPlain(P)
	
	local PopupTextDesc = Popup:GetChildChecked("PopupText", false):GetWidgetDesc()
	local PopupBtnDesc = Popup:GetChildChecked("PopupBtn", false):GetWidgetDesc()
	ColorBtnDesc = ColorOptions:GetChildChecked("PopupBtn", false):GetWidgetDesc()
	
	for i = 0, 4 do
		PopupText[i] = mainForm:CreateWidgetByDesc( PopupTextDesc )
		Popup:AddChild( PopupText[i] )
		PopupText[i]:Show(true)
		local P = PopupText[0]:GetPlacementPlain()
		P.posY = 20 * i
		PopupText[i]:SetPlacementPlain(P)
	end
	
	for i = 0, 13 do
		PopupBtn[i] = mainForm:CreateWidgetByDesc( PopupBtnDesc )
		Popup:AddChild( PopupBtn[i] )
		PopupBtn[i]:Show(true)
		local P = PopupBtn[0]:GetPlacementPlain()
		P.posY = 20 * i + 100
		PopupBtn[i]:SetPlacementPlain(P)
	end
	
	PopupBtn[0]:SetName("Whisper")
	PopupBtn[1]:SetName("Zone")
	PopupBtn[2]:SetName("Group")
	PopupBtn[3]:SetName("Say")
	PopupBtn[4]:SetName("Guild")
	PopupBtn[5]:SetName("Officer")
	PopupBtn[6]:SetName("Raid")
	PopupBtn[7]:SetName("Shout")
	PopupBtn[8]:SetName("World")
	PopupBtn[9]:SetName("Emote")
	PopupBtn[10]:SetName("Telepathy")
	PopupBtn[11]:SetName("System")
	PopupBtn[12]:SetName("BG")
	PopupBtn[13]:SetName("ChatType")
end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------